# -*- coding: utf-8 -*-
import heimdall
from lxml import etree


_URL_XMLSCHEMA = 'http://www.w3.org/2001/XMLSchema-instance'
_URL_HERA = 'https://gitlab.huma-num.fr/datasphere/hera/schema/schema.xsd'
_QNAME = etree.QName(_URL_XMLSCHEMA, "schemaLocation")


def create_root():
    return etree.Element('hera', {_QNAME: _URL_HERA})


def like_rilly_empty_db():
    return create_root()


def as_good_as_empty_db():
    root = create_root()
    etree.SubElement(root, 'properties')
    etree.SubElement(root, 'entities')
    etree.SubElement(root, 'items')
    return root


def only_1_item_pea_db():
    tree = create_root()
    etree.SubElement(tree, 'properties')
    heimdall.createProperty(tree, 'uid', name="Unique identifier")
    etree.SubElement(tree, 'entities')
    e = heimdall.createEntity(tree, 'entity', name="Some entity idk")
    heimdall.createAttribute(e, pid='uid')
    etree.SubElement(tree, 'items')
    heimdall.createItem(tree, eid='entity', uid='1337', name='shibboleet')
    return tree


def mini_consistent_db():
    tree = create_root()

    etree.SubElement(tree, 'properties')
    heimdall.createProperty(tree, 'uid', name="Unique identifier")
    heimdall.createProperty(tree, 'name', name="Human-readable identifier")
    heimdall.createProperty(tree, 'value', name="Some value idk lol")

    etree.SubElement(tree, 'entities')
    e = heimdall.createEntity(tree, 'entity', name="Some entity idk")
    heimdall.createAttribute(e, pid='uid', name="Unique identifier")
    heimdall.createAttribute(e, pid='value')
    heimdall.createEntity(tree, 'empty')

    heimdall.createItem(tree, value='double')
    heimdall.createItem(tree, eid='entity', uid='101010', value='double')
    heimdall.createItem(tree, uid='1337', name='shibboleet', value='other')
    return tree
